    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class represents an entry in the exception table of the <em>Code</em>
    62   * attribute and is used only there. It contains a range in which a
    63   * particular exception handler is active.
    64   *
    65   * @version $Id: CodeException.java,v 1.3 2002/07/11 19:39:04 mdahm Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     Code
    68   */
    69  public final class CodeException
    70    implements Cloneable, Constants, Node, Serializable
    71  {
    72    private int start_pc;   // Range in the code the exception handler is
    73    private int end_pc;     // active. start_pc is inclusive, end_pc exclusive
    74    private int handler_pc; /* Starting address of exception handler, i.e.,
    75  			   * an offset from start of code.
    76  			   */
    77    private int catch_type; /* If this is zero the handler catches any
    78  			   * exception, otherwise it points to the
    79  			   * exception class which is to be caught.
    80  			   */
    81    /***
    82     * Initialize from another object.
    83     */
    84    public CodeException(CodeException c) {
    85      this(c.getStartPC(), c.getEndPC(), c.getHandlerPC(), c.getCatchType());
    86    }
    87
    88    /***
    89     * Construct object from file stream.
    90     * @param file Input stream
    91     * @throws IOException
    92     */
    93    CodeException(DataInputStream file) throws IOException
    94    {
    95      this(file.readUnsignedShort(), file.readUnsignedShort(),
    96  	 file.readUnsignedShort(), file.readUnsignedShort());
    97    }
    98
    99    /***
    100    * @param start_pc Range in the code the exception handler is active,
    101    * start_pc is inclusive while
    102    * @param end_pc is exclusive
    103    * @param handler_pc Starting address of exception handler, i.e.,
    104    * an offset from start of code.
    105    * @param catch_type If zero the handler catches any
    106    * exception, otherwise it points to the exception class which is
    107    * to be caught.
    108    */
    109   public CodeException(int start_pc, int end_pc, int handler_pc,
    110 		       int catch_type)
    111   {
    112     this.start_pc   = start_pc;
    113     this.end_pc     = end_pc;
    114     this.handler_pc = handler_pc;
    115     this.catch_type = catch_type;
    116   }
    117
    118   /***
    119    * Called by objects that are traversing the nodes of the tree implicitely
    120    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    121    * fields, attributes, etc. spawns a tree of objects.
    122    *
    123    * @param v Visitor object
    124    */
    125   public void accept(Visitor v) {
    126     v.visitCodeException(this);
    127   }
    128   /***
    129    * Dump code exception to file stream in binary format.
    130    *
    131    * @param file Output file stream
    132    * @throws IOException
    133    */
    134   public final void dump(DataOutputStream file) throws IOException
    135   {
    136     file.writeShort(start_pc);
    137     file.writeShort(end_pc);
    138     file.writeShort(handler_pc);
    139     file.writeShort(catch_type);
    140   }
    141
    142   /***
    143    * @return 0, if the handler catches any exception, otherwise it points to
    144    * the exception class which is to be caught.
    145    */
    146   public final int getCatchType() { return catch_type; }
    147
    148   /***
    149    * @return Exclusive end index of the region where the handler is active.
    150    */
    151   public final int getEndPC() { return end_pc; }
    152
    153   /***
    154    * @return Starting address of exception handler, relative to the code.
    155    */
    156   public final int getHandlerPC() { return handler_pc; }
    157
    158   /***
    159    * @return Inclusive start index of the region where the handler is active.
    160    */
    161   public final int getStartPC() { return start_pc; }
    162
    163   /***
    164    * @param catch_type.
    165    */
    166   public final void setCatchType(int catch_type) {
    167     this.catch_type = catch_type;
    168   }
    169
    170   /***
    171    * @param end_pc end of handled block
    172    */
    173   public final void setEndPC(int end_pc) {
    174     this.end_pc = end_pc;
    175   }
    176
    177   /***
    178    * @param handler_pc where the actual code is
    179    */
    180   public final void setHandlerPC(int handler_pc) {
    181     this.handler_pc = handler_pc;
    182   }
    183
    184   /***
    185    * @param start_pc start of handled block
    186    */
    187   public final void setStartPC(int start_pc) {
    188     this.start_pc = start_pc;
    189   }
    190
    191   /***
    192    * @return String representation.
    193    */
    194   public final String toString() {
    195     return "CodeException(start_pc = " + start_pc +
    196       ", end_pc = " + end_pc +
    197       ", handler_pc = " + handler_pc + ", catch_type = " + catch_type + ")";
    198   }
    199
    200   /***
    201    * @return String representation.
    202    */
    203   public final String toString(ConstantPool cp, boolean verbose) {
    204     String str;
    205
    206     if(catch_type == 0)
    207       str = "<Any exception>(0)";
    208     else
    209       str = Utility.compactClassName(cp.getConstantString(catch_type, CONSTANT_Class), false) +
    210 	(verbose? "(" + catch_type + ")" : "");
    211
    212     return start_pc + "\t" + end_pc + "\t" + handler_pc + "\t" + str;
    213   }
    214
    215   public final String toString(ConstantPool cp) {
    216     return toString(cp, true);
    217   }
    218
    219   /***
    220    * @return deep copy of this object
    221    */
    222   public CodeException copy() {
    223     try {
    224       return (CodeException)clone();
    225     } catch(CloneNotSupportedException e) {}
    226
    227     return null;
    228   }
    229 }

This page was automatically generated by Maven